# Use docker image for all jobs
image: docker:19

# Use docker-in-docker service for all jobs
services:
  - docker:19-dind

# We currently only do building/pushing
# (Might do test/deployment as well)
stages:
  - buildAndPush

# Define re-usable variables
variables:
  IMAGE_TAG_ADMIN: $CI_REGISTRY_IMAGE/admin:$CI_COMMIT_REF_SLUG
  IMAGE_TAG_PRESENTATION: $CI_REGISTRY_IMAGE/presentation:$CI_COMMIT_REF_SLUG
  IMAGE_TAG_WORKER: $CI_REGISTRY_IMAGE/worker:$CI_COMMIT_REF_SLUG

# Configure job for building image using docker
build and push container image for admin-module:
  stage:  buildAndPush
  only:
    - branches
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --pull -t $IMAGE_TAG_ADMIN -f Admin.Dockerfile .
    - docker push $IMAGE_TAG_ADMIN

# Configure job for building image using docker
build and push container image for presentation-module:
  stage:  buildAndPush
  only:
    - branches
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --pull -t $IMAGE_TAG_PRESENTATION -f Presentation.Dockerfile .
    - docker push $IMAGE_TAG_PRESENTATION

# Configure job for building image using docker
build and push container image for worker-module:
  stage:  buildAndPush
  only:
    - branches
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --pull -t $IMAGE_TAG_WORKER -f Worker.Dockerfile .
    - docker push $IMAGE_TAG_WORKER
